VAR
  byte   pin, presentTeeth, missingTeeth, cog
  long   frequencyRate

  long   pulse, sync, timing, localIndex
  long   stack[20]

PUB start(p, pt, mt, initFrequency)
  pin := p
  presentTeeth := pt
  missingTeeth := mt
  setFrequency( initFrequency )

  if cog
    cogstop( cog-1 )

  cog := cognew( crankPulser, @stack )+1

PUB setFrequency( newFrequ )
  frequencyRate := (newFrequ #> 1 ) <# 500

  timing := clkfreq / frequencyRate

PUB getFrequency
  return frequencyRate
  
PRI crankPulser

'' Output 1 to 500Hz signal on pin
'' -- high-going pulse is fixed to 1ms
'' -- pntr is hub address of signal frequency (1 to 500Hz)

  dira[pin] := 1                                                ' make output 

  frqa := 1
  phsa := 0
  ctra := (%00100 << 26) | (%111 << 23) | pin                   ' setup counter for pin

  pulse := clkfreq / 1_000                                      ' ticks in 1ms
  
  sync := cnt                                                   ' sync with system clock  
  repeat
    
    repeat localIndex from 1 to (presentTeeth- missingTeeth)
      waitcnt(sync += timing)                                     ' hold for current hz setting
      phsa := -pulse                                              ' create 1ms pulse
    
    repeat localIndex from 1 to (missingTeeth)
      'phsa := -pulse                                              ' create 1ms pulse
      waitcnt(sync += timing)